// ML1 - multilot clone based on sma filter  ------------------------4 hour chart shows greatest returns
// author - fryk@tlen.pl, 2006

#include <stdlib.mqh>
//+------------------------------------------------------------------+
//| Common External variables                                        |
//+------------------------------------------------------------------+
extern double Lots = 0.1;
extern double StopLoss = 51.0;
extern double TakeProfit = 13.00;

//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+
extern double MaxTrades = 5;
extern double Pips = 3;
extern double AccountProtection = 1;
extern double mm = 0;
extern double risk = 0.15;
//extern double AccountisNormal = 0;
extern int mP = 28;
extern int mI = 2;
extern double mL = 2;
extern double timeframe = 60;      //cog2 timeperiod//use 60 on 4 hour chart
extern double Par      = 10;       //cog2
extern double CountBars = 300;      //cog2
extern double VHF_Period = 28;      //vhf period

extern bool UseHourTrade = false;  //timefilter
extern int FromHourTrade = 0;      //timefilter
extern int ToHourTrade = 24;       //timefilter

extern bool Usefilewrite=false;
int handle=0;
extern double MagicNumber=01020304;
//+------------------------------------------------------------------+
//| Global variables                                               |
//+------------------------------------------------------------------+
double OpenOrders = 0;
int cnt = 0,ticket=0;
double slippage = 5;
double sl = 0;
double tp = 0;
double BuyPrice = 0;
double SellPrice = 0;
double lotsi = 0;
double mylotsi = 0,LotIncreaseFactor=0;
double mode = 0;
double MyOrderType=0;
bool ContinueOpening = True;
double LastPrice = 0;
double PreviousOpenOrders = 0;
double Profit = 0;
double LastTicket = 0;
double LastType = 0;
double LastClosePrice = 0;
double LastLots = 0;



int start(){
if (UseHourTrade){
if (!(Hour()>=FromHourTrade && Hour()<=ToHourTrade)) {
   Comment("Time for trade has not come else!");
   return(0);
   }
   }    
if( mm != 0 ) lotsi = NormalizeDouble( (AccountFreeMargin() / 50.0) * (risk/100.0), 2); else lotsi = Lots;

if ( lotsi < 0.01 ) lotsi = 0.01;
if( lotsi > 100 ) lotsi = 100;

OpenOrders = 0;
for( cnt = 0; cnt < OrdersTotal(); cnt++ ) {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if( OrderSymbol() ==  Symbol() ) OpenOrders++;
}
      
if( PreviousOpenOrders > OpenOrders ) {
//history(0);
   for( cnt = OrdersTotal()-1; cnt >= 0; cnt-- ) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      mode = OrderType();
      if( OrderSymbol() == Symbol() ) {
         if( mode ==  OP_BUY )  
         {

        /*  if (Usefilewrite)
            {  
               if(OrderProfit()>0)
               {   
                  handle = FileOpen("MLCVV1timefilter.txt",FILE_READ|FILE_WRITE);
                  if(handle!=-1)
                    {
                    FileSeek(handle,0,SEEK_END);
                    FileWrite(handle,"Winning Long OrderTicket: ",OrderTicket());
                    FileWrite(handle,"  ");
                    
                    FileFlush(handle);
	                 FileClose(handle);
	                 //Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
	                 }   
                    else
                    {
                    int err;
                    err=GetLastError();
                    Print("error(",err,"): ",ErrorDescription(err));
                    //return(0);                     
                    } 
                 }//if win
               if(OrderProfit()<=0)
               {   
                  handle = FileOpen("MLCVV1timefilter.txt",FILE_READ|FILE_WRITE);
                  if(handle!=-1)
                    {
                    FileSeek(handle,0,SEEK_END);
                    FileWrite(handle,"Losing Long OrderTicket: ",OrderTicket());
                    FileWrite(handle,"  ");
                    
                    FileFlush(handle);
	                 FileClose(handle);
	                 //Print("Recorded Losing Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
	                 }   
                    else
                    {
                    int err1;
                    err1=GetLastError();
                    Print("error(",err1,"): ",ErrorDescription(err1));
                    //return(0);                     
                    } 
                 }//if win      
            }//usefilewrite */
         OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Blue);
         }
         if( mode ==  OP_SELL ) 
         {
         
         /* if (Usefilewrite)
            {  
               if(OrderProfit()>0)
               {   
                  handle = FileOpen("MLCVV1timefilter.txt",FILE_READ|FILE_WRITE);
                  if(handle!=-1)
                    {
                    FileSeek(handle,0,SEEK_END);
                    FileWrite(handle,"Winning Short OrderTicket: ",OrderTicket());
                    FileWrite(handle,"  ");
                    
                    FileFlush(handle);
	                 FileClose(handle);
	                 //Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
	                 }   
                    else
                    {
                    int err2;
                    err2=GetLastError();
                    Print("error(",err2,"): ",ErrorDescription(err2));
                    //return(0);                     
                    } 
                 }//if win
               if(OrderProfit()<=0)
               {   
                  handle = FileOpen("MLCVV1timefilter.txt",FILE_READ|FILE_WRITE);
                  if(handle!=-1)
                    {
                    FileSeek(handle,0,SEEK_END);
                    FileWrite(handle,"Losing Short OrderTicket: ",OrderTicket());
                    FileWrite(handle,"  ");
                    
                    FileFlush(handle);
	                 FileClose(handle);
	                 //Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
	                 }   
                    else
                    {
                    int err3;
                    err3=GetLastError();
                    Print("error(",err3,"): ",ErrorDescription(err3));
                    //return(0);                     
                    } 
                 }//if win      
            }//usefilewrite */
         
         
         OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Red);
         }
         Sleep(20);
      }
   }
   OpenOrders=0;
}

PreviousOpenOrders = OpenOrders;
if( OpenOrders >= MaxTrades ) ContinueOpening = False ; else ContinueOpening = True;

double ma1=iMA(NULL,PERIOD_M15,mP,0,0,5,0+mI);
double ma2=iMA(NULL,PERIOD_M15,mP,0,0,5,1+mI);
double cogup=iCustom(NULL,timeframe,"Center of Gravity",Par,CountBars,0,0);
double cogdown=iCustom(NULL,timeframe,"Center of Gravity",Par,CountBars,1,0);
double ivhf=iCustom(NULL,0,"VHF",VHF_Period,0,0);
double ivhf1=iCustom(NULL,0,"VHF",VHF_Period,0,1);
bool NewOrder=false;

if ( MathAbs(ma1-ma2)/Point > mL )
{
   NewOrder = true;
}

if( OpenOrders < 1 ) MyOrderType=0;
if( OpenOrders < 1 && NewOrder == true && ma1 < ma2 && cogup < cogdown && ivhf > ivhf1 ) {
   LastPrice = 0;
   MyOrderType=1;
}
if( OpenOrders < 1 && NewOrder == true && ma1 > ma2 && cogup > cogdown && ivhf > ivhf1 ) {
   LastPrice = 0;
   MyOrderType=2;
}

LastTicket = 0;
LastType = 0;
LastClosePrice = 0;
LastLots = 0;

for( cnt = 0; cnt < OrdersTotal(); cnt++ ) {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if( OrderSymbol() == Symbol() ) {
         LastPrice = OrderOpenPrice();
         if(OrderType()==OP_BUY)  MyOrderType=2;
         if(OrderType()==OP_SELL)  MyOrderType=1;

      LastTicket = OrderTicket();
      if( OrderType() ==  OP_BUY ) LastType = 0;
      if( OrderType() ==  OP_SELL ) LastType = 1;
      LastClosePrice = OrderClosePrice();
      LastLots = OrderLots();
   }
}

if( MyOrderType == 1 && ContinueOpening ) {
   if( Bid - LastPrice >= Pips * Point || OpenOrders < 1 ) {
      SellPrice = Bid;
      LastPrice = 0;
      if( TakeProfit ==  0 ) tp = 0 ; else tp = SellPrice - TakeProfit * Point;
      if( StopLoss ==  0 ) sl = 0 ; else sl = SellPrice + StopLoss * Point;
      if( OpenOrders != 0 ) {
         mylotsi = lotsi;
         for(cnt =0;cnt <OpenOrders;cnt ++) {
            if( MaxTrades > 12 ) mylotsi = NormalizeDouble(mylotsi * 1.5,2) ; else mylotsi = NormalizeDouble(mylotsi * 2,2);
         }
      }
      else {
         mylotsi = lotsi;
      }
///SHORTS //Added by Aaragorn 12-18-06 to increase lots based on account free margin 
///also based on the following ratios of win/loss for each position
//open orders	total winners	totallosers	nettotal	 %W	        %L
//    0         	 326	          177	      503	  0.648111332	0.351888668
//    1	          310	          105	      415	  0.746987952	0.253012048
//    2	          228	           46	      274	  0.832116788	0.167883212
//    3	          162	           29	      191	  0.848167539	0.151832461
//    4	          97	           24	      121	  0.801652893	0.198347107

    
if( OpenOrders == 0 )
{
mylotsi = Lots;
  ObjectDelete("Lots");
  ObjectCreate("Lots", OBJ_TEXT, 0, Time[10], Low[0]+(0*Point));
  ObjectSetText("Lots","Sell Lots: "+DoubleToStr(mylotsi,2),30,"Arial",Orange);
}
if( OpenOrders == 1 )
{
mylotsi = Lots*2;
  ObjectDelete("Lots");
  ObjectCreate("Lots", OBJ_TEXT, 0, Time[10], Low[0]+(0*Point));
  ObjectSetText("Lots","Sell Lots: "+DoubleToStr(mylotsi,2),30,"Arial",Orange);
}
if(OpenOrders == 2)
{
   mylotsi = Lots*8;
   if(AccountFreeMargin()>1800)
      {
      double s1=0;
      LotIncreaseFactor = 0.2;
      s1 = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000),2);
      mylotsi= MathMax(s1,mylotsi);
      }
  ObjectDelete("Lots");
  ObjectCreate("Lots", OBJ_TEXT, 0, Time[10], Low[0]+(0*Point));
  ObjectSetText("Lots","Sell Lots: "+DoubleToStr(mylotsi,2),30,"Arial",Orange);
}
if(OpenOrders == 3)
{
   mylotsi = Lots*16;
   if(AccountFreeMargin()>1500)
      {
      double s2=0;
      LotIncreaseFactor = 0.3;
      s2 = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000),2);
      mylotsi= MathMax(s2,mylotsi);
      }
  ObjectDelete("Lots");
  ObjectCreate("Lots", OBJ_TEXT, 0, Time[10], Low[0]+(0*Point));
  ObjectSetText("Lots","Sell Lots: "+DoubleToStr(mylotsi,2),30,"Arial",Orange);
  }
if(OpenOrders == 4)
{
   mylotsi = Lots*6;
   if(AccountFreeMargin()>2700)
      {
      double s3=0;
      LotIncreaseFactor = 0.16;
      s3 = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000),2);
      mylotsi= MathMax(s3,mylotsi);
      }
  ObjectDelete("Lots");
  ObjectCreate("Lots", OBJ_TEXT, 0, Time[10], Low[0]+(0*Point));
  ObjectSetText("Lots","Sell Lots: "+DoubleToStr(mylotsi,2),30,"Arial",Orange);
}
///      
      
      
      
      if( mylotsi > 10 ) mylotsi = 10;
      ticket=OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage,sl,tp,"",MagicNumber,0,Red);
      if(Usefilewrite && ticket>0)
         {
         if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
         //if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
            {
            handle = FileOpen("MLCVV1timefilter.txt",FILE_READ|FILE_WRITE);
            if(handle!=-1)
              {
               FileSeek(handle,0,SEEK_END);
               FileWrite(handle,"Opened Short #: ",OrderTicket(),"OpenOrders: ",OpenOrders," HistoryTotal ",HistoryTotal());
               FileFlush(handle);
               FileClose(handle);
              }   
              else
               {
               int err4;
               err4=GetLastError();
               Print("error(",err4,"): ",ErrorDescription(err4));

               return(0);                     
               }           
            }//if symbol and magic number                                        
         }//if use file write
      return(0);
   }
}

if( MyOrderType == 2 && ContinueOpening ) {
   if( LastPrice - Ask >= Pips * Point || OpenOrders < 1 ) {
      BuyPrice = Ask;
      LastPrice = 0;
      if( TakeProfit ==  0 ) tp = 0 ; else tp = BuyPrice + TakeProfit * Point;
      if( StopLoss ==  0 ) sl = 0 ; else sl = BuyPrice - StopLoss * Point;
      if( OpenOrders != 0 ) {
         mylotsi = lotsi;
         for(cnt =0;cnt <OpenOrders;cnt ++) {
            if( MaxTrades > 12 ) mylotsi = NormalizeDouble(mylotsi * 1.5,2) ; else mylotsi = NormalizeDouble(mylotsi * 2,2);
         }
      }
      else {
         mylotsi = lotsi;
      }
///LONGS //Added by Aaragorn 12-18-06 to increase lots based on account free margin 
///also based on the following ratios of win/loss for each position
//open orders	total winners	totallosers	nettotal	 %W	        %L
//    0         	 326	          177	      503	  0.648111332	0.351888668
//    1	          310	          105	      415	  0.746987952	0.253012048
//    2	          228	           46	      274	  0.832116788	0.167883212
//    3	          162	           29	      191	  0.848167539	0.151832461
//    4	          97	           24	      121	  0.801652893	0.198347107

    
if( OpenOrders == 0 )
{
mylotsi = Lots;
  ObjectDelete("Lots");
  ObjectCreate("Lots", OBJ_TEXT, 0, Time[10], Low[0]+(0*Point));
  ObjectSetText("Lots","Buy Lots: "+DoubleToStr(mylotsi,2),30,"Arial",Orange);
}
if( OpenOrders == 1 )
{
mylotsi = Lots*2;
  ObjectDelete("Lots");
  ObjectCreate("Lots", OBJ_TEXT, 0, Time[10], Low[0]+(0*Point));
  ObjectSetText("Lots","Buy Lots: "+DoubleToStr(mylotsi,2),30,"Arial",Orange);
}
if(OpenOrders == 2)
{
   mylotsi = Lots*8;
   if(AccountFreeMargin()>1800)
      {
      double L1=0;
      LotIncreaseFactor = 0.2;
      L1 = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000),2);
      mylotsi= MathMax(L1,mylotsi);
      }
  ObjectDelete("Lots");
  ObjectCreate("Lots", OBJ_TEXT, 0, Time[10], Low[0]+(0*Point));
  ObjectSetText("Lots","Buy Lots: "+DoubleToStr(mylotsi,2),30,"Arial",Orange);
}
if(OpenOrders == 3)
{
   mylotsi = Lots*16;
   if(AccountFreeMargin()>1500)
      {
      double L2=0;
      LotIncreaseFactor = 0.3;
      L2 = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000),2);
      mylotsi= MathMax(L2,mylotsi);
      }
  ObjectDelete("Lots");
  ObjectCreate("Lots", OBJ_TEXT, 0, Time[10], Low[0]+(0*Point));
  ObjectSetText("Lots","Buy Lots: "+DoubleToStr(mylotsi,2),30,"Arial",Orange);
  }
if(OpenOrders == 4)
{
   mylotsi = Lots*6;
   if(AccountFreeMargin()>2700)
      {
      double L3=0;
      LotIncreaseFactor = 0.16;
      L3 = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000),2);
      mylotsi= MathMax(L3,mylotsi);
      }
  ObjectDelete("Lots");
  ObjectCreate("Lots", OBJ_TEXT, 0, Time[10], Low[0]+(0*Point));
  ObjectSetText("Lots","Buy Lots: "+DoubleToStr(mylotsi,2),30,"Arial",Orange);
}
///        
      
      
      
      if( mylotsi > 10 ) mylotsi = 10;
      ticket=OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage,sl,tp,"",MagicNumber,0,Blue);
      if(Usefilewrite && ticket>0)
         {
         if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
         //if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
            {
            handle = FileOpen("MLCVV1timefilter.txt",FILE_READ|FILE_WRITE);
            if(handle!=-1)
              {
               FileSeek(handle,0,SEEK_END);
               FileWrite(handle,"Opened Long #: ",OrderTicket()," OpenOrders: ",OpenOrders," HistoryTotal ",HistoryTotal());
               FileFlush(handle);
               FileClose(handle);
              }   
              else
               {
               int err5;
               err5=GetLastError();
               Print("error(",err5,"): ",ErrorDescription(err5));

               return(0);                     
               }           
            }//if select                                        
         }//if use file write
      return(0);
   }
}


   
return(0);
}
int init()
{
return(0);
}
int deinit()
{
Print("HistoryTotal: ",HistoryTotal());
//history(0);
bool Hist = false;
  if(HistoryTotal()>20 )
  {
  Print("HistoryTrue");
  Hist = true;
  }//if count trigger 
  if(Hist==true)
  { 
  Print("IF HistoryTrue?"); 
   int cntt;
   for(cntt=0;cntt<HistoryTotal();cntt ++) 
         { 
         Print("History cnt ",cntt);  
            if(OrderSelect(cntt, SELECT_BY_TICKET)==true)
               {
               handle = FileOpen("MLCVV1timefilter.txt",FILE_READ|FILE_WRITE);
               if(handle!=-1)
                 {
                  FileSeek(handle,0,SEEK_END);
                  FileWrite(handle,"Order ",OrderTicket(),"profit: ",OrderProfit());
                  FileFlush(handle);
                  FileClose(handle);
                 }   
                 else
                  {
                  int err5;
                  err5=GetLastError();
                  Print("error(",err5,"): ",ErrorDescription(err5));
                  return(0);                     
                  }                   
               }//select
         }//for cntt
   Hist = false;
   Print("HistoryFalse"); 
  }//if Hist 
return(0);
}

void history(int count)
{
  bool Hist = false;
  if(HistoryTotal()>500 && HistoryTotal()<506)
  {
  Hist = true;
  }//if count trigger 
  if(HistoryTotal()>1000 && HistoryTotal()<1006)
  {
  count = 500;
  Hist = true;
  }//if count trigger 
  if(HistoryTotal()>1500 && HistoryTotal()<1506)
  {
  count = 1000;
  Hist = true;
  }//if count trigger  

   
  if(Hist==true)
  {  
   for(cnt=count;cnt<HistoryTotal();cnt ++) 
   { 
   //Print("History cnt ",cnt);  
   if(OrderSelect(cnt, SELECT_BY_TICKET)==true)
      {
      handle = FileOpen("MLCVV1timefilter.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
         FileSeek(handle,0,SEEK_END);
         FileWrite(handle,"Order ",OrderTicket(),"profit: ",OrderProfit());
         FileFlush(handle);
         FileClose(handle);
        }   
        else
         {
         int err5;
         err5=GetLastError();
         Print("error(",err5,"): ",ErrorDescription(err5));
         return(0);                     
         }                   
      }//select
   }//for cnt
   Hist = false;
  }//if Hist 
}//history